#!/usr/bin/env python
import os

"""
This is the meta how do i script

This takes an initially empty repo
and initializes the fuck out of it.


Meta repo (called how-do-i) stores template
.gitignore, LICENSE, README, mkdocsyml,
index.md, and Makefile files.


Algorithm:
    - read configuration file values
    - input: name of how-do-i repo, --> url of how do i
    - git clone
    - to add:
        - add a .gitignore
        - add a LICENSE
        - add a README.md
        - add an mkdocs.yml 
            - name of site, predictable urls
            - index.md-only in TOC
        - add a docs folder
        - add a docs/index.md file
        - add mkdocs-material submodule
        - add Makefile (simple: site and deploy docs only)
    - git:
        - create site/ from this repo
        - checkout orphan gh-pages
        - init checkin of hello world
"""

repo_list = ["how-do-i-api"]

root_dir = os.path.join(os.environ['HOME'],'codes','how')
meta_dir = os.path.join(root_dir,'how-do-i')

if not os.path.isdir(root_dir):
    raise Exception("ERROR: Specified root dir %s is not a directory"%(root_dir))

if not os.path.isdir(meta_dir):
    raise Exception("ERROR: Specified meta how-do-i dir %s is not a directory"%(meta_dir))


# -------
# Generic values
generic_gitea_url = "https://git.charlesreid1.com/charlesreid1/{repo}"
generic_pages_url = "https://pages.charlesreid1.com/{repo}"
generic_reponame = "charlesreid1/{repo}"
generic_repo_dir = os.path.join(root_dir,'{repo}')

# Apply operation for each user-specified repo
for repo in repo_list:

    print("Initializing repository %s"%(repo))

    gitea_url = generic_gitea_url.format(repo=repo)
    pages_url = generic_pages_url.format(repo=repo)
    reponame = generic_reponame.format(repo=repo)
    repo_dir = generic_repo_dir.format(repo=repo)

    #clone_cmd = ['git','clone',git_url,repo_dir]
    #subprocess.call(clone_cmd, cwd=root_dir)




    #subprocess.call(['touch','.gitignore'])
    #subprocess.call(['touch','LICENSE'])
    #subprocess.call(['touch','README'])
    #subprocess.call(['touch','mkdocs.yml'])
    #subprocess.call(['mkdir','docs'])
    #subprocess.call(['touch','docs/index.md'])
    #subprocess.call(['git','submodule','add','https://git.charlesreid1.com/charlesreid1/mkdocs-material.dib'])

    pass


